//*****************************************************************************************************
//  1. t@C
//		DataManagerKitting.cpp
//----------------------------------------------------------------------------------------------------
//  2. @\
//		CDataManager NX̃Cve[ViLbg֘Aj
//----------------------------------------------------------------------------------------------------
//  3. l
//----------------------------------------------------------------------------------------------------
//  4. 
//		2006.09.01 S.Aizawa(xxx) VK쐬
//*****************************************************************************************************

#include "stdafx.h"
#include "workscheduler.h"

//*****************************************************************************************************
//  1. ֐
//		CDataManager::GetKittingData
//----------------------------------------------------------------------------------------------------
//  2. @\
//		Lbg擾
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//----------------------------------------------------------------------------------------------------
//  5. Tv
//		N񂩂LbgɕKvȏ擾B
//----------------------------------------------------------------------------------------------------
//  6. l
//----------------------------------------------------------------------------------------------------
//  7. 
//		2006.09.01 S.Aizawa(xxx) VK쐬
//*****************************************************************************************************
void CDataManager::GetKittingData()
{
	int nSublineNum = m_aSubline.GetSize();
	for (int nSublineId = 0; nSublineId < nSublineNum; nSublineId++)
		GetKittingDataSub(nSublineId);
}

void CDataManager::GetKittingDataSub(int nSublineId)
{
	SSubline &cSubline = m_aSubline[nSublineId];
	int i, j, k;
	int nIndex;
	int nKishuId;
	int nKishuNum = m_aKishu.GetSize();

	cSubline.aKittingYosoSagyogun.RemoveAll();
	cSubline.aKittingBuhin.RemoveAll();

	// 폜tOɕsvƂ邩`FbN
	BOOL bSetFuyoSagyo = FALSE;
	int nYosoSagyogunNum = cSubline.aYosoSagyogun.GetSize();
	for (int nYosoSagyogunId = 0; nYosoSagyogunId < nYosoSagyogunNum; nYosoSagyogunId++) {
		SYosoSagyogun &cYosoSagyogun = cSubline.aYosoSagyogun[nYosoSagyogunId];
		int nYosoSagyoNum = cYosoSagyogun.aYosoSagyo.GetSize();
		for (int nYosoSagyoId = 0; nYosoSagyoId < nYosoSagyoNum; nYosoSagyoId++) {
			if (cYosoSagyogun.aYosoSagyo[nYosoSagyoId].bKittingDelete) {
				bSetFuyoSagyo = TRUE;
				break;
			}
		}
		if (bSetFuyoSagyo)
			break;
	}

	// i\HNf[^ɂ郋[v
	int nBuhinhyoLink = m_aBuhinhyoLink.GetSize();
	for (i = 0; i < nBuhinhyoLink; i++) {
		SBuhinhyoLink &cBuhinhyoLink = m_aBuhinhyoLink[i];

		if (cBuhinhyoLink.sSublineName.CompareNoCase(cSubline.sSublineName) == 0) {
			if (CheckKittingBuhinNo(cBuhinhyoLink)) {
				// vfƌQɂ郋[v
				int nYosoSagyogunNum = cBuhinhyoLink.aYosoSagyogunName.GetSize();
				for (j = 0;j < nYosoSagyogunNum; j++) {
					CString &sYosoSagyogunName = cBuhinhyoLink.aYosoSagyogunName[j];
					SYosoSagyogun *pYosoSagyogun = GetYosoSagyogun(nSublineId, cBuhinhyoLink.sKoteiName, sYosoSagyogunName);
					if (pYosoSagyogun != NULL) {
						// H/vfƌQZbg
						SKittingYosoSagyogun *pKittingYosoSagyogun = cSubline.aKittingYosoSagyogun.LookupElement(cBuhinhyoLink.sKoteiName + sYosoSagyogunName, nIndex);
						if (pKittingYosoSagyogun == NULL) {
							pKittingYosoSagyogun = cSubline.aKittingYosoSagyogun.AddElement(cBuhinhyoLink.sKoteiName + sYosoSagyogunName, nIndex);
							pKittingYosoSagyogun->sKoteiName = cBuhinhyoLink.sKoteiName;
							pKittingYosoSagyogun->sYosoSagyogunName = sYosoSagyogunName;

							int nYosoSagyo = pYosoSagyogun->aYosoSagyo.GetSize();
							for (k = 0; k < nYosoSagyo; k++) {
								SYosoSagyo &cYosoSagyo = pYosoSagyogun->aYosoSagyo[k];
								if (cYosoSagyo.sDeleteFlag != "1" && cYosoSagyo.sDeleteFlag != "2") {
									SKittingYosoSagyo *pKittingYosoSagyo = pKittingYosoSagyogun->aKittingYosoSagyo.AddElement();
									pKittingYosoSagyo->sYosoSagyoName = cYosoSagyo.sYosoSagyoName;
									pKittingYosoSagyo->nSagyoNo = cYosoSagyo.nSagyoNo;
									pKittingYosoSagyo->nYosoSagyoId = k;
									pKittingYosoSagyo->fTime = cYosoSagyo.fTime;
									pKittingYosoSagyo->bSakujoFlag = bSetFuyoSagyo ? cYosoSagyo.bKittingDelete : CheckDefaultSakujoSagyo(cYosoSagyo.sYosoSagyoNo);
								}
							}
						}

						// iZbg
						SKittingBuhin *pKittingBuhin = cSubline.aKittingBuhin.LookupElement(cBuhinhyoLink.sBuhinNo);
						if (pKittingBuhin == NULL) {
							pKittingBuhin = cSubline.aKittingBuhin.AddElement(cBuhinhyoLink.sBuhinNo);
							pKittingBuhin->sBlockNo = cBuhinhyoLink.sBlockNo;
							pKittingBuhin->sBuhinNo = cBuhinhyoLink.sBuhinNo;
							pKittingBuhin->sBuhinName = cBuhinhyoLink.sBuhinName;
							pKittingBuhin->aPC.SetSize(nKishuNum);

							SBuhinKitting *pBuhinKitting = cSubline.aBuhinKitting.LookupElement(cBuhinhyoLink.sBuhinNo);
							pKittingBuhin->bCheck = (pBuhinKitting != NULL) ? pBuhinKitting->bKittingFlag : (cSubline.aBuhinKitting.GetSize() == 0);
						}

						if (m_aKishu.LookupElement(cBuhinhyoLink.sKishu, nKishuId) != NULL)
							pKittingBuhin->aPC[nKishuId] = cBuhinhyoLink.nPC;

						int nSize = pKittingBuhin->aKittingYosoSagyogunId.GetSize();
						for (k = 0; k < nSize; k++) {
							if (pKittingBuhin->aKittingYosoSagyogunId[k] == nIndex)
								break;
						}
						if (k == nSize)
							pKittingBuhin->aKittingYosoSagyogunId.Add(nIndex);
					}
				}
			}
		}
	}
}

//*****************************************************************************************************
//  1. ֐
//		CDataManager::CheckKittingBuhinNo
//----------------------------------------------------------------------------------------------------
//  2. @\
//		LbgΏۂ̕iԍ`FbN
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		CString		&sBuhinNo			[I] iԍ
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		BOOL		FALSEFLbgΏەiłȂCTRUEFLbgΏەił
//----------------------------------------------------------------------------------------------------
//  5. Tv
//		w肳ꂽiԍLbgΏەi`FbNB
//----------------------------------------------------------------------------------------------------
//  6. l
//----------------------------------------------------------------------------------------------------
//  7. 
//		2006.09.01 S.Aizawa(xxx) VK쐬
//*****************************************************************************************************
BOOL CDataManager::CheckKittingBuhinNo(const SBuhinhyoLink &cBuhinhyoLink)
{
/*
	int i;

	// iԍ̕擾
	int nLength = sBuhinNo.GetLength();

	// TȂΏۊO
	if (nLength < 5)
		return FALSE;

	// 擪TɐȊOΏۊO
	for (i = 0; i < 5; i++) {
		if (sBuhinNo[i] < '0' || sBuhinNo[i] > '9')
			return FALSE;
	}
*/
	// {gtOONȂΏۊO
	if (cBuhinhyoLink.bBoltFlag)
		return FALSE;

	// ΏۊOit@CɊ܂܂ĂΑΏۊO
	if (m_aKittingTaishogai.LookupElement(cBuhinhyoLink.sBuhinNo.Left(5)) != NULL)
		return FALSE;

	return TRUE;
}

//*****************************************************************************************************
//  1. ֐
//		CDataManager::CheckDefaultSakujoSagyo
//----------------------------------------------------------------------------------------------------
//  2. @\
//		ftHg̍폜Ώۍƃ`FbN
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		CString		&sYosoSagyoNo			[I] vfƔԍ
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		BOOL		FALSEF폜ΏۍƂłȂCTRUEF폜ΏۍƂł
//----------------------------------------------------------------------------------------------------
//  5. Tv
//		w肳ꂽvfƔԍLbgɂ폜Ώۂ`FbNB
//----------------------------------------------------------------------------------------------------
//  6. l
//----------------------------------------------------------------------------------------------------
//  7. 
//		2006.09.01 S.Aizawa(xxx) VK쐬
//*****************************************************************************************************
BOOL CDataManager::CheckDefaultSakujoSagyo(const CString &sYosoSagyoNo)
{
	if (sYosoSagyoNo == "031"
		|| sYosoSagyoNo == "093"
		|| sYosoSagyoNo == "097"
		|| sYosoSagyoNo == "098"
		|| sYosoSagyoNo == "100")
		return TRUE;

	return FALSE;
}

//*****************************************************************************************************
//  1. ֐
//		CDataManager::DeleteKittingSagyo
//----------------------------------------------------------------------------------------------------
//  2. @\
//		Lbgɂvfƍ폜
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//----------------------------------------------------------------------------------------------------
//  5. Tv
//		Lbgɂ폜ΏۂƂȂvfƂvfƌQf[^폜B
//----------------------------------------------------------------------------------------------------
//  6. l
//----------------------------------------------------------------------------------------------------
//  7. 
//		2006.09.01 S.Aizawa(xxx) VK쐬
//*****************************************************************************************************
void CDataManager::DeleteKittingSagyo(int nSublineId)
{
	SSubline &cSubline = m_aSubline[nSublineId];
	int i, j, k;

	int nKittingBuhin = cSubline.aKittingBuhin.GetSize();
	for (i = 0; i < nKittingBuhin; i++) {
		SKittingBuhin &cKittingBuhin = cSubline.aKittingBuhin[i];
		int nYosoSagyogun = cKittingBuhin.aKittingYosoSagyogunId.GetSize();
		for (j = 0; j < nYosoSagyogun; j++) {
			SKittingYosoSagyogun &cKittingYosoSagyogun = cSubline.aKittingYosoSagyogun[cKittingBuhin.aKittingYosoSagyogunId[j]];
			SYosoSagyogun *pYosoSagyogun = GetYosoSagyogun(nSublineId, cKittingYosoSagyogun.sKoteiName, cKittingYosoSagyogun.sYosoSagyogunName);
			if (pYosoSagyogun != NULL) {
				int nYosoSagyo = cKittingYosoSagyogun.aKittingYosoSagyo.GetSize();
				for (k = 0; k < nYosoSagyo; k++) {
					SKittingYosoSagyo &cKittingYosoSagyo = cKittingYosoSagyogun.aKittingYosoSagyo[k];
					pYosoSagyogun->aYosoSagyo[cKittingYosoSagyo.nYosoSagyoId].bKittingDelete = cKittingYosoSagyo.bSakujoFlag;
				}
			}
		}
	}

	// f[^XVtOݒ
	m_bUpdate = TRUE;
}

//*****************************************************************************************************
//  1. ֐
//		CDataManager::AddKittingTemplate
//----------------------------------------------------------------------------------------------------
//  2. @\
//		Lbgƃev[gǉ
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//----------------------------------------------------------------------------------------------------
//  5. Tv
//		vfƕ\ɃLbgƂǉB
//----------------------------------------------------------------------------------------------------
//  6. l
//----------------------------------------------------------------------------------------------------
//  7. 
//		2006.09.01 S.Aizawa(xxx) VK쐬
//*****************************************************************************************************
void CDataManager::AddKittingTemplate(int nSublineId)
{
	CWaitCursor cWaitCursor;
	SSubline &cSubline = m_aSubline[nSublineId];
	int i, j;
	int nRow, nCol;
	long nUsedRows, nUsedCols;
	CString sKoteiNo;
	CIntArrayEx aTemplate1;
	CIntArrayEx aTemplate2;
	CIntArrayEx aKittingBuhin;
	_variant_t vData;
	CString sText;
	int nKishuId;
	int nYosoSagyogunJunban;

	// ev[g̍s擾
	nUsedRows = m_eKittingTemplate.GetUsedRows();
	for (nRow = 1; nRow <= nUsedRows; nRow++) {
		m_eKittingTemplate.GetElement(nRow, m_eYosoSagyoHyo.eColKoteiNo, sKoteiNo);

		if (sKoteiNo == "001")
			aTemplate1.Add(nRow);

		if (sKoteiNo == "002")
			aTemplate2.Add(nRow);
	}
	int nTemplate1Rows = aTemplate1.GetSize();
	int nTemplate2Rows = aTemplate2.GetSize();

	int nLastRowIndex = cSubline.aRowArray.GetSize();

	// ev[gPRs[
	nUsedCols = m_eKittingTemplate.GetUsedCols();
	for (i = 0; i < nTemplate1Rows; i++) {
		nRow = m_eYosoSagyoHyo.AddRows();
		for (nCol = 1; nCol <= nUsedCols; nCol++) {
			m_eKittingTemplate.GetElement(aTemplate1[i], nCol, vData);

			if (nCol == m_eYosoSagyoHyo.eColTsuikaFlag)
// Modify ... ( CHANGE )
				vData = "1";
//				vData = "3";
// By Y.Itabashi (xxxxx) 2007.02.21
			else if (nCol == m_eYosoSagyoHyo.eColSublineName)
				vData = cSubline.sSublineName;

// Modify ... ( ADD )
			if( nCol == m_eYosoSagyoHyo.eColKoteiKigo )
				m_eKittingTemplate.GetElement(aTemplate1[i], nCol, m_sKittingKoteiKigo);
// By Y.Itabasshi (xxxxx) 2007.03.07

			m_eYosoSagyoHyo.PutElement(nRow, nCol, vData);
		}
		cSubline.aRowArray.Add(nRow);
	}

	// ev[gQRs[
	int nKittingBuhin = cSubline.aKittingBuhin.GetSize();
	for (i = 0; i < nKittingBuhin; i++) {
		SKittingBuhin &cKittingBuhin = cSubline.aKittingBuhin[i];

		if (cKittingBuhin.bCheck) {
			for (j = 0; j < nTemplate2Rows; j++) {
				nRow = m_eYosoSagyoHyo.AddRows();
				for (nCol = 1; nCol <= nUsedCols; nCol++) {
					m_eKittingTemplate.GetElement(aTemplate2[j], nCol, vData);

					if (nCol == m_eYosoSagyoHyo.eColTsuikaFlag)
// Modify ... ( CHANGE )
						vData = "1";
//						vData = "3";
// By Y.Itabashi (xxxxx) 2007.02.21
					else if (nCol == m_eYosoSagyoHyo.eColSublineName)
						vData = cSubline.sSublineName;
					else if (nCol == m_eYosoSagyoHyo.eColKoteiNo) {
						sText.Format("%03d", i + 2);
						vData = sText;
					} else if (nCol == m_eYosoSagyoHyo.eColKoteiName || nCol == m_eYosoSagyoHyo.eColYosoSagyogunName) {
						m_eKittingTemplate.GetElement(aTemplate2[j], nCol, sText);
						sText.Replace("$", cKittingBuhin.sBuhinName);
						vData = sText;
					}
					m_eYosoSagyoHyo.PutElement(nRow, nCol, vData);
				}

				// @ʂɗvfƌQԂݒ
				int nSize = m_eYosoSagyoHyo.m_aKishuCols[1].aKishuCols.GetSize();
				for (int k = 0; k < nSize; k++) {
					nYosoSagyogunJunban = 0;
					SKishuCols &cKishuCols = m_eYosoSagyoHyo.m_aKishuCols[1].aKishuCols[k];
					if (m_aKishu.LookupElement(cKishuCols.sKishuName, nKishuId) != NULL) {
						if (cKittingBuhin.aPC[nKishuId] != 0)
							nYosoSagyogunJunban = 1;
					}
					m_eYosoSagyoHyo.PutElement(nRow, cKishuCols.nCol, nYosoSagyogunJunban);
				}

				cSubline.aRowArray.Add(nRow);
			}
		}
	}

	// vfƌQ𒊏o
	ExtractYosoSagyogunSub(nSublineId, nLastRowIndex);

	// vfƌQԂݒ
	int nKishuNum = m_aKishu.GetSize();
	for (nKishuId = 0; nKishuId < nKishuNum; nKishuId++) {
		CSagyojunArray aSagyojun;
		GetKittingSagyojun(nSublineId, nKishuId, aSagyojun);
		OrderByKittingSagyojun(nSublineId, aSagyojun);
	}

	// f[^XVtOݒ
	m_bUpdate = TRUE;
}

//*****************************************************************************************************
//  1. ֐
//		CDataManager::CancelKitting
//----------------------------------------------------------------------------------------------------
//  2. @\
//		Lbg
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//----------------------------------------------------------------------------------------------------
//  5. Tv
//		LbgƂvfƌQf[^폜ALbgɂ폜ꂽvfƂ𕜊B
//----------------------------------------------------------------------------------------------------
//  6. l
//----------------------------------------------------------------------------------------------------
//  7. 
//		2006.09.01 S.Aizawa(xxx) VK쐬
//*****************************************************************************************************
void CDataManager::CancelKitting(int nSublineId)
{
	SSubline &cSubline = m_aSubline[nSublineId];
	CYosoSagyogunArray &aYosoSagyogun = cSubline.aYosoSagyogun;
	int i, j;

	cSubline.aYosoSagyogunKit.RemoveAll();

	int nYosoSagyogun = aYosoSagyogun.GetSize();
	for (i = 0; i < nYosoSagyogun; i++) {
		SYosoSagyogun &cYosoSagyogun = aYosoSagyogun[i];
		int nYosoSagyo = cYosoSagyogun.aYosoSagyo.GetSize();
		for (j = 0; j < nYosoSagyo; j++) {
			SYosoSagyo &cYosoSagyo = cYosoSagyogun.aYosoSagyo[j];
			if (cYosoSagyo.sDeleteFlag == "3")
				cYosoSagyo.sDeleteFlag = "";
		}
	}

	aYosoSagyogun.MakeKey();

	// f[^XVtOݒ
	m_bUpdate = TRUE;

	// LbgLtOZbg
	cSubline.bSetKitting = FALSE;
}

// ̕ĩLbg
void CDataManager::CancelKitting(int nSublineId, LPCTSTR pKoteiName)
{
	SSubline &cSubline = m_aSubline[nSublineId];

	// Lbgev[gH擾
	CString sKoteiNo;
	CString sKoteiName;
	int nUsedRows = m_eKittingTemplate.GetUsedRows();
	for (int nRow = 1; nRow <= nUsedRows; nRow++) {
		m_eKittingTemplate.GetElement(nRow, m_eYosoSagyoHyo.eColKoteiNo, sKoteiNo);
		if (sKoteiNo == "002") {
			m_eKittingTemplate.GetElement(nRow, m_eYosoSagyoHyo.eColKoteiName, sKoteiName);
			break;
		}
	}

	// H畔i𒊏o
	CString sBuhinName = pKoteiName;
	sKoteiName.Replace("$", "");
	int nPos = sBuhinName.Find(sKoteiName);
	if (nPos >= 0) {
		sBuhinName.Delete(nPos, sKoteiName.GetLength());

		// i\HNf[^ɂ郋[v
		int nBuhinhyoLink = m_aBuhinhyoLink.GetSize();
		for (int i = 0; i < nBuhinhyoLink; i++) {
			SBuhinhyoLink &cBuhinhyoLink = m_aBuhinhyoLink[i];

			// i\HNTuCƕivf[^T
			if (cBuhinhyoLink.sSublineName == cSubline.sSublineName && cBuhinhyoLink.sBuhinName == sBuhinName) {
				int nSize = cBuhinhyoLink.aYosoSagyogunName.GetSize();
				for (int j = 0; j < nSize; j++) {
					CString &sYosoSagyogunName = cBuhinhyoLink.aYosoSagyogunName[j];

					// iɃNĂvfƌQ𕜊
					int nYosoSagyogunNum = cSubline.aYosoSagyogun.GetSize();
					for (int nYosoSagyogunId = 0; nYosoSagyogunId < nYosoSagyogunNum; nYosoSagyogunId++) {
						SYosoSagyogun &cYosoSagyogun = cSubline.aYosoSagyogun[nYosoSagyogunId];
						if (cYosoSagyogun.sYosoSagyogunName == sYosoSagyogunName) {
							int nYosoSagyoNum = cYosoSagyogun.aYosoSagyo.GetSize();
							for (int nYosoSagyoId = 0; nYosoSagyoId < nYosoSagyoNum; nYosoSagyoId++) {
								SYosoSagyo &cYosoSagyo = cYosoSagyogun.aYosoSagyo[nYosoSagyoId];
								if (cYosoSagyo.sDeleteFlag == "3")
									cYosoSagyo.sDeleteFlag.Empty();
							}
							cYosoSagyogun.bKittingCancel = TRUE;
						}
					}
				}

				// ĩLbgtONA
				SKittingBuhin *pKittingBuhin = cSubline.aKittingBuhin.LookupElement(cBuhinhyoLink.sBuhinNo);
				if (pKittingBuhin != NULL)
					pKittingBuhin->bCheck = FALSE;
			}
		}

		// LbgƂYi̍Ƃ폜
		int nYosoSagyogunNum = cSubline.aYosoSagyogunKit.GetSize();
		for (int nYosoSagyogunId = 0; nYosoSagyogunId < nYosoSagyogunNum; nYosoSagyogunId++) {
			SYosoSagyogun &cYosoSagyogun = cSubline.aYosoSagyogunKit[nYosoSagyogunId];
			if (cYosoSagyogun.sKoteiName == pKoteiName) {
				cSubline.aYosoSagyogunKit.RemoveAt(nYosoSagyogunId);
				break;
			}
		}
	}
}

// iLbgt@Cݒ
void CDataManager::SetBuhinKitting()
{
	int nSublineNum = m_aSubline.GetSize();
	for (int nSublineId = 0; nSublineId < nSublineNum; nSublineId++) {
		SSubline &cSubline = m_aSubline[nSublineId];
	
		cSubline.aBuhinKitting.RemoveAll();

		int nBuhinNum = cSubline.aKittingBuhin.GetSize();
		for (int i = 0; i < nBuhinNum; i++) {
			SKittingBuhin &cKittingBuhin = cSubline.aKittingBuhin[i];
			SBuhinKitting *pBuhinKitting = cSubline.aBuhinKitting.AddElement(cKittingBuhin.sBuhinNo);
			pBuhinKitting->sBlockNo = cKittingBuhin.sBlockNo;
			pBuhinKitting->sBuhinNo = cKittingBuhin.sBuhinNo;
			pBuhinKitting->sBuhinName = cKittingBuhin.sBuhinName;
			pBuhinKitting->bKittingFlag = cKittingBuhin.bCheck;
		}

		SetKittingDeleteFlagSub(nSublineId);
	}
}

// LbgtONA
void CDataManager::ClearKittingCancelFlag()
{
	int nSublineNum = m_aSubline.GetSize();
	for (int nSublineId = 0; nSublineId < nSublineNum; nSublineId++) {
		SSubline &cSubline = m_aSubline[nSublineId];

		int nYosoSagyogunNum = cSubline.aYosoSagyogun.GetSize();
		for (int nYosoSagyogunId = 0; nYosoSagyogunId < nYosoSagyogunNum; nYosoSagyogunId++)
			cSubline.aYosoSagyogun[nYosoSagyogunId].bKittingCancel = FALSE;
	}
}

// vfƕ\ɃLbgɂ폜tOZbg
void CDataManager::SetKittingDeleteFlag()
{
	int nSublineNum = m_aSubline.GetSize();
	for (int nSublineId = 0; nSublineId < nSublineNum; nSublineId++)
		SetKittingDeleteFlagSub(nSublineId);
}

// vfƕ\ɃLbgɂ폜tOZbg
void CDataManager::SetKittingDeleteFlagSub(int nSublineId)
{
	SSubline &cSubline = m_aSubline[nSublineId];

	// Lbgɂ폜tOUSĐݒ肷
	int nYosoSagyogunNum = cSubline.aYosoSagyogun.GetSize();
	for (int nYosoSagyogunId = 0; nYosoSagyogunId < nYosoSagyogunNum; nYosoSagyogunId++) {
		SYosoSagyogun &cYosoSagyogun = cSubline.aYosoSagyogun[nYosoSagyogunId];

		int nYosoSagyoNum = cYosoSagyogun.aYosoSagyo.GetSize();
		for (int nYosoSagyoId = 0; nYosoSagyoId < nYosoSagyoNum; nYosoSagyoId++) {
			SYosoSagyo &cYosoSagyo = cYosoSagyogun.aYosoSagyo[nYosoSagyoId];
			if (cYosoSagyo.bKittingDelete && cYosoSagyo.sDeleteFlag.IsEmpty())
				cYosoSagyo.sDeleteFlag = "3";
		}
	}

	// Lbgݒ肳ĂȂi̗vfƂ̍폜tO
	int nBuhinhyoLinkNum = m_aBuhinhyoLink.GetSize();
	for (int i = 0; i < nBuhinhyoLinkNum; i++) {
		SBuhinhyoLink &cBuhinhyoLink = m_aBuhinhyoLink[i];

		SBuhinKitting *pBuhinKitting = cSubline.aBuhinKitting.LookupElement(cBuhinhyoLink.sBuhinNo);
		if (pBuhinKitting != NULL) {
			int nSize = cBuhinhyoLink.aYosoSagyogunName.GetSize();
			for (int j = 0; j < nSize; j++) {
				SYosoSagyogun *pYosoSagyogun = GetYosoSagyogun(nSublineId, cBuhinhyoLink.sKoteiName, cBuhinhyoLink.aYosoSagyogunName[j]);

				if (pYosoSagyogun != NULL) {
					int nYosoSagyoNum = pYosoSagyogun->aYosoSagyo.GetSize();
					for (int nYosoSagyoId = 0; nYosoSagyoId < nYosoSagyoNum; nYosoSagyoId++) {
						SYosoSagyo &cYosoSagyo = pYosoSagyogun->aYosoSagyo[nYosoSagyoId];
						if (!pBuhinKitting->bKittingFlag && cYosoSagyo.sDeleteFlag == "3")
							cYosoSagyo.sDeleteFlag.Empty();
					}
				}
			}
		}
	}
}
